<?php
# THIS FILE PROCESSES
# TEXTPATTERN'S IMAGES BY
# FETCHING THEM AND
# GENERATING A NEW FILE
# DYNAMICALLY / ON THE FLY
# WITH ***NEW*** IMAGE NAME

# SEND IMPREVEMENT IDEAS:
# petri.ikonen@kuopassa.com
# OR
# http://kuopassa.net/txp/

# THIS ONE IS GENERAL REQUEST ONLY
if (isset($_REQUEST)) {
    function url_cleaner($clean) {
        $clean = preg_replace('/[^a-zA-Z0-9\/_|+ -]/','',$clean);
        $clean = strtolower(trim($clean));
        $clean = preg_replace('/[\/_|+ -]+/','-',$clean);
        return $clean;
    }
}

# IF IMAGE REQUEST IS VIA AJAX
if ((isset($_REQUEST['raw_id'])) && (!empty($_REQUEST['raw_id'])) && (is_numeric($_REQUEST['raw_id'])) && (filter_var($_REQUEST['raw_id'],FILTER_VALIDATE_INT)) && 
(isset($_REQUEST['raw_name'])) && (!empty($_REQUEST['raw_name'])) && (!is_numeric($_REQUEST['raw_name'])) && (basename(__FILE__) === 'kuo_image_cleaner.php') && 
(isset($_REQUEST['raw_folder'])) && (!empty($_REQUEST['raw_folder']))) {

    # WE NEED IMAGE ID
    # IMAGE EXTENSION
    # IMAGE NAME
    $image_id = filter_var($_REQUEST['raw_id'],FILTER_SANITIZE_NUMBER_INT);
    $image_extension = filter_var(pathinfo($_REQUEST['raw_name'],PATHINFO_EXTENSION),FILTER_SANITIZE_STRING);
    $image_name = url_cleaner(filter_var(pathinfo($_REQUEST['raw_name'],PATHINFO_FILENAME),FILTER_SANITIZE_STRING));
    $image_folder = filter_var($_REQUEST['raw_folder'],FILTER_SANITIZE_STRING);

    if (file_exists('../'.$image_folder.'/'.$image_id.'.'.$image_extension)) {

        # IF USER CLICKS "MAKE A HARD COPY"
        # THEN LETS DO THAT
        if ((isset($_REQUEST['raw_copy'])) && (!empty($_REQUEST['raw_copy'])) && ($_REQUEST['raw_copy'] === $image_id)) {
            # LETS MAKE HARD COPY
            if (copy('../'.$image_folder.'/'.$image_id.'.'.$image_extension,'../'.$image_folder.'/'.$image_id.'-'.$image_name.'.'.$image_extension)) {
                echo 'Hard copy was created.';
            }
            # IF MAKING FAILS, ITS ERROR TIME
            else {
                echo 'Unable to make a hard copy.';
            }
            unset($_GET['raw_copy']);
        }
        # ELSE ITS JUST IMAGE URL
        else {
            echo $image_folder.'/'.$image_id.'-'.$image_name.'.'.$image_extension;
        }
        
    }

    unset($_GET['raw_id']);
    unset($_GET['raw_name']);
    unset($image_folder);
    unset($image_id);
    unset($image_extension);
    unset($image_name);
    die;
}

# IF IMAGE REQUEST IS VIA BROWSER
if ((isset($_GET['id'])) && (!empty($_GET['id'])) && (is_numeric($_GET['id'])) && (filter_var($_REQUEST['id'],FILTER_VALIDATE_INT)) && (isset($_GET['name'])) && (!empty($_GET['name'])) && (!is_numeric($_GET['name'])) && 
(isset($_GET['folder'])) && (!empty($_GET['folder']))) {
    
    # WE NEED IMAGE ID
    # IMAGE EXTENSION
    # IMAGE NAME
    $image_id = filter_var($_GET['id'],FILTER_SANITIZE_NUMBER_INT);
    $image_extension = filter_var(pathinfo($_GET['name'],PATHINFO_EXTENSION),FILTER_SANITIZE_STRING);
    $image_name = url_cleaner(filter_var(pathinfo($_GET['name'],PATHINFO_FILENAME),FILTER_SANITIZE_STRING));
    $image_folder = filter_var($_REQUEST['folder'],FILTER_SANITIZE_STRING);
    
    # IS IMAGE FILE THERE?
    if (file_exists('../'.$image_folder.'/'.$image_id.'.'.$image_extension)) {
        list($width,$height,$type,$attr) = getimagesize('../'.$image_folder.'/'.$image_id.'.'.$image_extension);
    }
    else {
        die;
    }
    
    # IF IMAGE EXISTS, LETS SEE IF ALL IS RIGHT
    if ((isset($width)) && (!empty($width)) && (is_numeric($width)) && (isset($height)) && (!empty($height)) && 
    (is_numeric($height)) && (isset($type)) && (!empty($type)) && (is_numeric($type)) && (isset($attr)) && (!empty($attr))) {
        $valid_image = TRUE;
    }
    else {
        $valid_image = FALSE;
    }
    
    # PREPARING TO OUTPUT IMAGE
    if (($valid_image === TRUE) && (isset($image_extension)) && (!empty($image_extension)) && (isset($image_name)) && (!empty($image_name)) && (isset($image_id)) && (!empty($image_id)) && (is_numeric($image_id))) {

        if (isset($_SERVER['HTTP_IF_MODIFIED_SINCE'])) {
            header('Last-Modified:'.$_SERVER['HTTP_IF_MODIFIED_SINCE'],true,304);
            die;
        }

        if ($type == 1) {
            header('Content-Type: image/gif');
        }
        elseif ($type === 2) {
            header('Content-Type: image/jpeg');
        }
        elseif ($type === 3) {
            header('Content-Type: image/png');
        }
        
        header('Last-Modified: '.gmdate('r',time()));
        header('Expires: '.gmdate('r',time() + 1800));
        header('Content-Length: '.filesize('../'.$image_folder.'/'.$image_id.'.'.$image_extension));
        
        # THIS ONE ACTUALLY DOES THE OUTPUTTING
        echo readfile('../'.$image_folder.'/'.$image_id.'.'.$image_extension);

        unset($_GET['id']);
        unset($_GET['name']);
        unset($image_folder);
        unset($image_id);
        unset($image_extension);
        unset($image_name);
        die;
    }
    else {
        unset($image_folder);
        unset($image_id);
        unset($image_extension);
        unset($image_name);
        die;
    }
}
else {
    die;
}
?>